/**
 * 汎用コンポーネント 画像
 */

(function() {
	var rule = {
		_name : 'BASICIMAGE01',
		_doc  : '選択要素から画像を取り出し、調整・変換の上出力する',

		start : {
			'#doc' : function startStartDoc(tagName, attrs) {
				this.displayWidth  = +gcutil.getTerminfoProperty('browserWidth') || Number.POSITIVE_INFINITY;
				this.imgWidth      = +this.getParameter('imgWidth');
				this.imgHeight     = +this.getParameter('imgHeight');
				this.unit          = this.getParameter('unit');
				this.clipX1        = this.getParameter('clipX1') || ' ';
				this.clipY1        = this.getParameter('clipY1') || ' ';
				this.clipX2        = this.getParameter('clipX2') || ' ';
				this.clipY2        = this.getParameter('clipY2') || ' ';
				this.clipCoords    = this.clipX1.replace(/^\s*|\s*$/g, '')
				                   + ','
				                   + this.clipY1.replace(/^\s*|\s*$/g, '')
				                   + ','
				                   + this.clipX2.replace(/^\s*|\s*$/g, '')
				                   + ','
				                   + this.clipY2.replace(/^\s*|\s*$/g, '');
				this.validateClip  = /^\d+,\d+,\d+,\d+$/.test(this.clipCoords);

				/* ver1.1.0 width属性、height属性の削除をするかどうかの指定 */
				this.removeSizeAttrs = this.getParameter('removeSizeAttrs');
				if (!this.removeSizeAttrs) {
					// 削除しないをデフォルトとする
					this.removeSizeAttrs = '0';
				}

				this._img = function(tagName, attrs) {
					var w = this.imgWidth;
					var h = this.imgHeight;
					if (this.unit === 'px') {
						if (w) {
							w = (w < this.displayWidth) ? w : '100%';
							attrs.set('width', w);
							attrs.remove('height');
						}
						if (h) {
							attrs.set('height', h);
							if (!w) {
								attrs.remove('width');
							}
						}
					} else if (this.unit === '%') {
						if (w) {
							attrs.set('width', w + '%');
							attrs.remove('height');
						}
						if (h) {
							attrs.set('height', h + '%');
							if (!w) {
								attrs.remove('width');
							}
						}
					} else {
						return null;
					}
					return {'tagName' : tagName, 'attrs' : attrs};
				};

				this.img = function(tagName, attrs) {
					var src = attrs.get('src');
					if (!src) {
						return null;
					}
					// ver1.1.0 width属性・height属性を削除するかどうか
					if (this.removeSizeAttrs == '1') {
						attrs.remove('width');
						attrs.remove('height');
					}
					if (this.validateClip) {
						// ver1.1.0 クリッピング使用時は絶対URLを相対に置換する
						attrs.set('gc-convert', 'on');

						var param = escape(this.clipCoords);
						if (src.indexOf("?") == -1) {
							src += "?_gccmd=clip%3D" + param;
						} else {
							src += "&_gccmd=clip%3D" + param;
						}
					}
					attrs.set('src', src);
					return this._img(tagName, attrs);
				};

				return this.OUT;
			}
		},

		step1 : {
			'a' : function step1StartA(tagName, attrs) {
				this.link = {'tagName' : tagName, 'attrs' : attrs};
				return this.CONTINUE;
			},

			'img' : function step1StartImg(tagName, attrs) {
				if (this.link) {
					this.addElement(this.link);
				}
				this.addElement(this.img(tagName, attrs));
				this.endElement();
				if (this.link) {
					this.endElement();
				}
				return this.CONTINUE;
			}

		},

		finished : {
			'/#doc' : function finishedEndDod(tagName) {
				return this.EXIT;
			}
		},

		failed : {
			'/#doc' : function failedEndDoc(tagName) {
				return this.ERROR;
			}
		}
	};
	gcparts.partsRules[rule._name] = rule;
}());