/**
 * 汎用コンポーネント パネル
 */


(function() {
	var rule = {
		_name : 'BASICPANEL02',
		_doc  : 'パネル',

		start : {
			'#doc' : function step1StartDoc() {
				this.displayWidth  = +gcutil.getTerminfoProperty('browserWidth') || Number.POSITIVE_INFINITY;

				this.isComment = this.getParameter('comment');
				if (this.isComment === "1") {
					this.isComment = true;
				} else {
					this.isComment = false;
				}

				/* itemが取れない場合にエラーを回避する */
				var _removes = this.getItem('step1.remove');
				var s;
				if (_removes) {
					s = this.getItem('step1.remove').getAttribute('value').replace(/\s*/g, '').split(',');
				} else {
					s = [];
				}
				this.a = {};
				for (var i = 0, l = s.length; i < l; i++) {
					/* v1.1.0 大文字の属性名に対応 */
					var name = s[i].toLowerCase();
					this.a[name] = name;
				}
				this.trim = function(attrs) {
					var ret = new gcparts.Attributes(attrs);
					for (var attr in attrs.attrs) {
						if (this.a[attr]) {
							ret.remove(attr);
						}
					}
					return ret;
				};

				return this.OUT;
			},
		},

		step1 : {
			'*' : function step1StartOther(tagName, attrs) {
				this.addElement({'tagName' : tagName, 'attrs' : this.trim(attrs)});
				return this.CONTINUE;
			},

			'#text' : function step1Text(data) {
				var d = data.replace(/^\s*|\s*$/g, '');
				if (d) {
					this.addText(d);
				}
				return this.CONTINUE;
			},
			'#comment' : function step1Comment(data) {
				if (this.isComment) {
					this.addComment(data);
				}
				return this.CONTINUE;
			},

			'img | object | table | applet' : function step1StartImg(tagName, attrs) {
				var w  = +attrs.get('width');
				var mw = this.displayWidth;
				if (w && w > mw) {
					attrs.set('width', '100%');
					attrs.remove('height');
				}
				/* ver1.1.0 属性削除を行う */
				this.addElement({ 'tagName' : tagName, 'attrs' : this.trim(attrs) });
				return this.CONTINUE;
			},

			'/img | /object | /table | /applet' : function step1EndImg(tagName, attrs) {
				this.endElement();
				return this.CONTINUE;
			},

			'/*' : function step1EndOther(tagName) {
				this.endElement();
				return this.CONTINUE;
			}
		},

		'finished' : {
			'/#doc' : function finishedEndDoc() {
				return this.EXIT;
			}
		},

		'failed' : {
			'/#doc' : function failedEndDoc() {
				return this.ERROR;
			}
		}
	};
	gcparts.partsRules[rule._name] =  rule;
}());
