/**
 * 汎用コンポーネント Google地図
 */

(function() {
	var rule = {
		_name : 'GOOGLEMAP01',
		_doc  : 'Google地図',

		start: {
			'#doc': function startStartDoc() {
				return this.OUT;
			}
		},

		finished: {
			'/#doc': function finishedEndDoc() {
				partsId = 'gcp' + gcutil.randomString(5, '_-');
				// スクリプト部分
				var _script = this.getItem('script');
				var _tlat = this.getParameter('tlat');
				var _tlong = this.getParameter('tlong');
				this.addElement(_script);
				this.addText('(function() { var outputArea = "map' + partsId + '";var tlat = ' + _tlat + ', tlong = ' + _tlong + ';');
				this.addText(_script.getElement().textContent);
				this.addText('}());');
				this.endElement();

				// マップ表示部分
				var _map = this.getItem('output');
				if (_map) {
					_map.setAttribute("id", "map" + partsId);
				} else {
					// ver 1.0.0用ロジック
					_map = this.getItem('map');
				}
				var _width = this.getParameter('width');
				var _unit_w = this.getParameter('unit_w');
				var _height = this.getParameter('height');
				var _unit_h = this.getParameter('unit_h');

				if (!_width) {
					_width = 100;
					_unit_w = '%';
				}
				if (!_height) {
					_height = 240;
					_unit_h = 'px';
				}
				_map.setAttribute('style', 'width:' + _width + _unit_w + '; height:' + _height + _unit_h + ';margin:0 auto;');
				this.addElement(_map);
				this.endElement();
				return this.EXIT;
			}
		},

		failed: {
			'/#doc': function failedEndDoc() {
				return this.EXIT;
			}
		}
	};
	gcparts.partsRules[rule._name] = rule;
}());
