/**
 * 汎用コンポーネント 背景付きメニュー
 */
(function() {


	var rule = {

		_name: "IMAGEMENU01",
		_dic: "背景付メニュー",

		start: {
			'#doc': function startStartDoc() {

				// オプション値の取得と正規化
				this.menuStyle = this.getParameter('menuStyle');
				if (!this.menuStyle) {
					this.menuStyle = 'floatList';
				}

				// アンカーは先頭を使う
				this.anchorIndex = 0;

				// フラグ変数の初期化
				this.isAddMenuStyle = false;

				// リストの深さカウンタ
				this.level = 0;

				// パーツID
				this.partsId = 'gcp' + gcutil.randomString(5, '_-');

				// PC側のアンカー属性のうち、出力に取り入れる属性定義（item:start.attrs）
				this.bringAttrs = {};
				var baList = ['href'];
				var item = this.getItem('start.attrs');
				if (item) {
					baList = item.getAttribute('value').replace(/\s*/g, '').split(',');
				}
				for (var i = 0; i < baList.length; i++) {
					/* v1.1.0 大文字の属性名に対応 */
					var ba = baList[i].toLowerCase();
					this.bringAttrs[ba] = ba;
				}

				// アンカーの属性マージ関数
				this.mergeAttrs = function(element, attrs) {
					for (var ar in attrs.attrs) {
						if (this.bringAttrs[ar]) {
							var value = attrs.get(ar);
							if (value) {
								element.setAttribute(ar, value);
							}
						}
					}
					return element;
				};

				var _def = this.getItem('start.bgimage');
				if (_def) {

					try {
						var _value = _def.getElement().textContent;
						if (_value.match(/^[ \r\n\t\f]*$/)) {
							if (gclog.isDebugEnabled()) {
								gclog.debug('[start.bgimage] is empty', 2);
							}
						} else {
							if (!_value.match(/[\{\}]/)) {
								_value = '{' + _value + '}';
							}
							if (gclog.isDebugEnabled()) {
								gclog.debug('[start.bgimage]' + _value, 2);
							}
							this.bgImages = eval('(' + _value + ')');
						}
					} catch(err) {
						if (gclog.isDebugEnabled()) {
							gclog.debug('cannot read [start.bgimage] in view', 2);
						}
					}
				} else {
					if (gclog.isDebugEnabled()) {
						gclog.debug('cannot find [start.bgimage] in view', 2);
					}
				}

				// 置換キーワード定義（JSON形式）
				var _keywords = this.getItem('start.keywords');
				if (_keywords) {
					try {
						var _node = _keywords.getElement();
						if (_node) {
							var _value = _node.textContent || '';
							if (_value.match(/^[ \r\n\t\f]*$/)) {
								if (gclog.isDebugEnabled()) {
									gclog.debug('[start.keywords] is empty', 2);
								}
							} else {
								if (!_value.match(/[\{\}]/)) {
									_value = '{' + _value + '}';
								}
								if (gclog.isDebugEnabled()) {
									gclog.debug('[start.keywords]' + _value, 2);
								}
								// 本来ならJSON.parseするが、カンマで終わるフォーマットを不正扱いしたくないので、evalを使用する
								this.keywords = eval('(' + _value + ')');
							}
						}
					} catch(err) {
						gclog.error('cannot read gcl format[start.keywords]' + err, 2);
					}

				}

				this.convertKeywords = function(text) {
					if (!this.keywords) {
						return text;
					}
					var result = text;
					for (var k in this.keywords) {
						result = result.split(k).join(this.keywords[k]);
					}
					return result;
				}

				return this.OUT;
			}
		},

		step1: {

			'ul | ol' : function step1StartUl(tagName, attrs) {

				// 最初の１回だけデザイン用要素をツリーに出力
				if (!this.isAddMenuStyle) {
					var _menuStyle = this.getStep();
					_menuStyle.setAttribute('id', this.partsId);
					this.addElement(_menuStyle);
					this.isAddMenuStyle = true;
				}

				// ヘルパーに溜まっているデータを出力する
				if (this.subTree && this.menuItem && this.menuItem.hasContent()) {

					// サブメニュー表示用要素追加
					this.menuItem.setSubMenu(true);
					// サブツリーに保管中のLIの子に、ヘルパー生成結果のツリーを追加
					this.subTree.addTree(this.menuItem._getTree());
					this.addTree(this.subTree);

					this.subTree = undefined;
					this.menuItem = undefined;
				}

				// リストの深さを下げる
				this.level++;

				var elem = this.getItem('step1.menu');
				var c = elem.getAttribute('class') || '';

				c += this.level;
				elem.setAttribute('class', c);

				this.addElement(elem);
				return this.CONTINUE;
			},

			'/ul | /ol' : function step1EndUl(tagName) {

				this.endElement();
				// リストの深さを戻す
				this.level--;

				return this.CONTINUE;
			},

			'li' : function step1StartLi(tagName, attrs) {

				this.subTree = new gcparts.ElementTree();

				var elem = this.getItem('step1.item');
				this.subTree.addElement(elem);

				this.menuItem = new gcparts.ImageMenuMaker({ icon: this.getItem('step1.menuIcon'), text: this.getItem('step1.text'), subTree: this.getItem('step1.subtree')});

				if (this.bgImages) {
					var gcidx = attrs.get('gcidx');
					if (gcidx) {
						var img = this.bgImages[gcidx];
						if (img) {
							this.menuItem.setBackgroundImage(img);
						}
					}
				}

				return this.CONTINUE;
			},

			'/li' : function step1EndLi(tagName) {

				// ヘルパーに溜まっているデータを出力する
				if (this.subTree && this.menuItem && this.menuItem.hasContent()) {

					this.subTree.addTree(this.menuItem._getTree());
					this.subTree.endElement();

					this.addTree(this.subTree);

					this.subTree = undefined;
					this.menuItem = undefined;

				}
				return this.CONTINUE;
			},

			'a' : function step1StartA(tagName, attrs) {

				if (!this.menuItem) {
					return this.CONTINUE;
				}

				var elem = this.getItem('step1.anchor');

				if (this.bgImages) {
					var gcidx = attrs.get('gcidx');
					if (gcidx) {
						var img = this.bgImages[gcidx];
						if (img) {
							this.menuItem.setBackgroundImage(img);
						}
					}
				}
				var _title = attrs.get('title') || '';
				if (!_title.match(/^[ \r\n\t\f]*$/)) {
					attrs.set('title', this.convertKeywords(_title));
				}
				this.menuItem.setAnchorElement(this.mergeAttrs(elem, attrs));
				return this.CONTINUE;

			},

			'#text' : function step1StartText(data) {

				if (!this.menuItem) {
					return this.CONTINUE;
				}

				var nbsp = String.fromCharCode( 160 );
				var d = data.replace(nbsp,'');

				if (!d.match(/^[ \r\n\t\f]*$/)) {
					var item = this.getItem('step1.text');
					this.menuItem.addItem(item, this.convertKeywords(data));
				}

				return this.CONTINUE;
			},

			'img' : function step1StartImg(tagName, attrs) {

				if (!this.menuItem) {
					return this.CONTINUE;
				}
				var alt = attrs.get('alt');
				var nbsp = String.fromCharCode( 160 );
				alt = alt.replace(nbsp,'');
				if (!alt.match(/^[ \r\n\t\f]*$/)) {
					attrs.set('alt', this.convertKeywords(alt));
					this.menuItem.addItem({ 'tagName' : tagName,  'attrs' : attrs });
				}
				return this.CONTINUE;
			},

			'script | style' : function step1StartScriptStyle(tagName, attrs) {
				return this.TRASH;
			},


			'*' : function step1StartOther(tagName, attrs) {
				// 背景画像があるかを見る
				if (!this.menuItem) {
					return this.CONTINUE;
				}

				if (this.bgImages) {
					var gcidx = attrs.get('gcidx');
					if (gcidx) {
						var img = this.bgImages[gcidx];
						if (img) {
							this.menuItem.setBackgroundImage(img);
						}
					}
				}

				return this.CONTINUE;

			}

		},

		finished: {
			'/#doc': function finishedStartDoc() {

				// 出力するメニューデータがないため、出力を空にする
				if (this.countAddedStep('step1') == 0) {
					return this.ERROR;
				} else if (this.countAddedItem('step1.item') == 0) {
					return this.ERROR;
				}

				// クライアントサイドJavaScriptの出力
				var script = this.getItem('finished.script');
				if (script) {

					var _node = script.getElement();
					if (_node) {
						this.addElement(script);
						var code = _node.textContent || '';
						code = code.split("#gcpId").join("#" + this.partsId);
						this.addText(code);
						this.endElement();
					}
				}
				return this.EXIT;
			}
		},

		failed: {
			'/#doc': function failedEndDoc() {
				return this.EXIT;
			}
		}
	};

	gcparts.partsRules[rule._name] = rule;

}());
