/**
 * jQuery Mobile フォームパーツ
 */

(function() {
	var rule = {
		_name: "JQMFLIPSWITCH01",
		_dic: "jQueryMobile フリップスイッチパーツ",

		start : {
			'#doc' : function step1StartDoc() {

				// パラメータの取得・初期化
				// フォームID
				this.formId = this.getParameter('formId') || '';

				// 入力HTMLに含まれるフォームコンポーネント以外のコンテンツを出力するかどうか
				this.panelMode = this.getParameter('panelMode') || 'OFF';

				// 注釈
				this.footerTexts = [];
				for (var i = 0; i < 100; i++) {
					this.footerTexts[i] = this.getParameter('footerText' + (i + 1)) || '';
				}
				// フリップスイッチ出現カウンタ
				this.flipIndex = 0;

				// スイッチOff,Onの表示ラベル
				this.stateOff = this.getParameter('stateOff') || 'Off';
				this.stateOn = this.getParameter('stateOn') || 'On';

				// ミニサイズ表示
				this.miniSize = this.getParameter('miniSize') || 'OFF';
				// 入力の必須化
				this.required = this.getParameter('required') || 'OFF';
				// エラーメッセージ部分の探し方
				this.errorTextType = this.getParameter('errorTextType') || '';
				// エラーメッセージ部分の指定値
				this.errorTextValue = this.getParameter('errorTextValue') || '';
				// ラベルIDの振り直し
				this.resetLabelId = this.getParameter('resetLabelId') || 'OFF';
				// ラジオボタンのグループ連結
				this.grouping = this.getParameter('grouping') || 'OFF';

				// バッファ変数
				// 見出し
				this.titleTree = new gcparts.ElementTree('titleTree');
				// コンテンツ本体ツリー
				this.contentTree = new gcparts.ElementTree('contentTree');

				// title / label / errorTextのどれかによって処理を違えるべく、step2sにサスペンド時に値を保持する
				this.itemName;

				// PC側のフォーム系要素の属性のうち、削除する属性定義（ブラックリスト）（item:start.removeAttrs）
				var _removes = this.getItem('start.removeAttrs');
				if (_removes) {
					this.removes = _removes.getAttribute('value').replace(/\s*/g, '').split(',');
				} else {
					this.removes = [];
				}
				this.removeAttrs = function(attrs) {
					if (!attrs) {
						return attrs;
					}
					this.removes.forEach(function(r){
						r = r.toLowerCase();
						if (attrs.has(r)) {
							attrs.remove(r);
						}
					});
					return attrs;
				}
				this.matchClassAttribute = function(classNames, target) {
					var _class = classNames.split(' ');
					for (var i = 0; i < _class.length; i++) {
						if (_class[i] == target) {
							// find class attribute value
							return true;
						}
					}
					return false;
				}
				return this.OUT;
			},
		},

		step1: {

			'input': function step1StartInput(tagName, attrs) {
				var _type = attrs.get('type') || '';
				_type = _type.toLowerCase();

				switch(_type) {
				case 'checkbox':

					this.flipTree = new gcparts.ElementTree('flipTree');
					var _select = this.getStep();
					_select.setAttribute('data-role', 'slider');
					_select.setAttribute('name', attrs.get('name'));

					this.labelId = attrs.get('id');
					if (!this.labelId) {
						this.labelId = 'gcp_' + attrs.get('name') + '_' + attrs.get('value');
					} else if (this.resetLabelId == 'ON') {
						this.labelId = 'gcp_' + attrs.get('name') + '_' + attrs.get('value');
					}
					_select.setAttribute('id', this.labelId);

					if (this.miniSize == 'ON') {
						// ミニサイズ表示
						_select.setAttribute('data-mini', 'true');
					}
					if (this.required == 'ON') {
						// 入力の必須化
						_select.setAttribute('required', 'required');
					}
					if (this.formId) {
						// form属性の設定
						_select.setAttribute('form', this.formId);
					}
					this.flipTree.addElement(_select);
					// OFF state
					var _off = this.getItem('option');
					if (attrs.has('checked')) {
						_off.setAttribute('selected', 'selected');
					}
					this.flipTree.addElement(_off);
					this.flipTree.addText(this.stateOff);
					this.flipTree.endElement();	// close option element(off state)
					// ON state
					var _on = this.getItem('option');
					_on.setAttribute('value', attrs.get('value'));
					if (attrs.has('checked')) {
						_on.setAttribute('selected', 'selected');
					}
					this.flipTree.addElement(_on);
					this.flipTree.addText(this.stateOn);
					this.flipTree.endElement();	// close option element(on state)

					this.flipTree.endElement();	// close select element
					this.flipTree.isRadio = false;

					break;

				case 'radio':

					if (this.flipTree && this.flipTree.radioName != attrs.get('name')) {

						var _wrapper = this.getStep('flipswitch');
						this.contentTree.addElement(_wrapper);

						if (this.flipTree.countAddedStep('step1') > 0) {
							this.flipTree.endElement();
						}
						this.contentTree.addTree(this.flipTree);	// add select & option elements
						this.flipTree = undefined;

						// 注釈テキストの表示
						if (this.panelMode == 'OFF') {
							if (this.flipIndex < this.footerTexts.length && this.footerTexts[this.flipIndex]) {
								var _note = this.getItem('note');
								if (_note) {
									this.contentTree.addElement(_note);
									this.contentTree.addText(this.footerTexts[this.flipIndex]);
									this.contentTree.endElement();
								} else {
									this.contentTree.addText(this.footerTexts[this.flipIndex]);
								}
							}
						}
						this.flipIndex++;
						this.contentTree.endElement(); // close wrapper element
					}

					if (!this.flipTree) {
						this.flipTree = new gcparts.ElementTree('flipTree');

						var _select = this.getStep();
						_select.setAttribute('data-role', 'slider');
						_select.setAttribute('name', attrs.get('name'));

						this.labelId = attrs.get('id');
						if (!this.labelId) {
							this.labelId = 'gcp_' + attrs.get('name') + '_' + attrs.get('value');
						} else if (this.resetLabelId == 'ON') {
							this.labelId = 'gcp_' + attrs.get('name') + '_' + attrs.get('value');
						}
						_select.setAttribute('id', this.labelId);

						if (this.miniSize == 'ON') {
							// ミニサイズ表示
							_select.setAttribute('data-mini', 'true');
						}
						if (this.required == 'ON') {
							// 入力の必須化
							_select.setAttribute('required', 'required');
						}
						if (this.formId) {
							// form属性の設定
							_select.setAttribute('form', this.formId);
						}
						this.flipTree.addElement(_select);
					}

					var _option = this.getItem('option');
					_option.setAttribute('value', attrs.get('value'));
					if (attrs.has('checked')) {
						_option.setAttribute('selected', 'selected');
					}
					// add <option value="X">
					this.flipTree.addElement(_option);

					this.flipTree.isRadio = true;
					this.flipTree.radioName = attrs.get('name');

					break;

				default:
					return this.SUSPEND;
				}
				return this.CONTINUE;
			},

			'/input' : function step1EndInput(tagName, attrs) {
				// テキストノード待ち
				this.skip = true;
				return this.CONTINUE;
			},

			'#text': function step1Text(data) {
				var nbsp = String.fromCharCode( 160 );
				var d = data.replace(nbsp,'');
				if (d.match(/^[ \r\n\t\f]*$/)) {
					return this.CONTINUE;
				}

				if (this.labelTree) {
					this.labelTree.addText(data);
				} else if (this.skip){
					if (this.flipTree && this.flipTree.isRadio) {
						// ラジオボタンを処理中。TextNodeはoption要素の中に入れる
						// <option value="X">data</option>
						this.flipTree.addText(data);
						this.flipTree.endElement();

					} else {
						var _label = this.getItem('label');
						if (this.labelId) {
							_label.setAttribute('for', this.labelId);
							this.labelId = undefined;
						}
						// フリップスイッチ、ラベルをラップする要素
						var _wrapper = this.getItem('flipswitch');
						this.contentTree.addElement(_wrapper);
						this.contentTree.addElement(_label);
						this.contentTree.addText(data);
						this.contentTree.endElement();

						if (this.flipTree) {
							// フリップスイッチを出力
							this.contentTree.addTree(this.flipTree);
							// 注釈テキストの表示
							if (this.panelMode == 'OFF') {
								if (this.flipIndex < this.footerTexts.length && this.footerTexts[this.flipIndex]) {
									var _note = this.getItem('note');
									if (_note) {
										this.contentTree.addElement(_note);
										this.contentTree.addText(this.footerTexts[this.flipIndex]);
										this.contentTree.endElement();
									} else {
										this.contentTree.addText(this.footerTexts[this.flipIndex]);
									}
								}
							}
							this.flipIndex++;
						}
						this.contentTree.endElement(); // close wrapper element
						this.flipTree = undefined;
					}
					this.skip = false;
				} else if (this.panelMode != 'OFF') {
					this.contentTree.addData(data);
				}
				return this.CONTINUE;
			},

			'label': function step1StartLabel(tagName, attrs) {
				this.skip = true;
				this.labelTree = new gcparts.ElementTree('labelTree');

				if (attrs.has('for')) {
					this.labelTree.addElement(tagName, this.removeAttrs(attrs));
				}
				return this.CONTINUE;
			},

			'/label': function step1EndLabel(tagName, attrs) {

				if (this.flipTree && this.flipTree.isRadio) {
					// ラジオボタンを処理中。optionを閉じる
					if (this.labelTree && this.labelTree.hasElement(tagName)) {
						this.labelTree.endElement();
					}
					this.flipTree.addTree(this.labelTree);
					this.flipTree.endElement();

				} else {
					// フリップスイッチ、ラベルをラップする要素
					var _wrapper = this.getItem('flipswitch');
					this.contentTree.addElement(_wrapper);

					if (this.labelTree && this.labelTree.hasElement(tagName)) {
						// label要素追加済み
						this.labelTree.endElement();
						this.contentTree.addTree(this.labelTree);
					} else if (this.labelTree && !this.labelTree.isEmpty()) {
						var _label = this.getItem('label');
						if (this.labelId) {
							_label.setAttribute('for', this.labelId);
							this.labelId = undefined;
						}
						this.contentTree.addElement(_label);
						this.contentTree.addTree(this.labelTree);
						this.contentTree.endElement();
					}
					if (this.flipTree) {
						this.contentTree.addTree(this.flipTree);
						// 注釈テキストの表示
						if (this.panelMode == 'OFF') {
							if (this.flipIndex < this.footerTexts.length && this.footerTexts[this.flipIndex]) {
								var _note = this.getItem('note');
								if (_note) {
									this.contentTree.addElement(_note);
									this.contentTree.addText(this.footerTexts[this.flipIndex]);
									this.contentTree.endElement();
								} else {
									this.contentTree.addText(this.footerTexts[this.flipIndex]);
								}
							}
						}
						this.flipIndex++;
					}
					this.contentTree.endElement(); // close _wrapper element
					this.flipTree = undefined;
				}

				this.skip = false;
				this.labelTree = undefined;
				return this.CONTINUE;
			},

			'*': function step1StartOther(tagName, attrs) {
				if (this.skip) {
					return this.CONTINUE;
				}
				if (this.panelMode != 'OFF' && this.labelTree && !this.labelTree.isEmpty()) {
					this.contentTree.addTree(this.labelTree);
				}
				this.labelTree = undefined;
				return this.SUSPEND;
			},

			'/*': function step1EndOther(tagName) {
				if (this.skip) {
					return this.CONTINUE;
				}
				if (this.panelMode == 'OFF') {
					// パネルモードOFF
					return this.CONTINUE;
				}
				this.contentTree.endElement();
				return this.CONTINUE;
			}

		},

		step2s: {

			'*': function step2sStartOther(tagName, attrs) {
				var gclabel = attrs.get("data-gc-label");
				switch(gclabel) {
				case 'title':
					// 見出し用のラベルパスまたは固定文言の指定
					this.itemName = 'title';
					return this.SUSPEND;
				}
				// エラーメッセージ部分の指定がされている場合は、SUSPEND
				if (this.errorTextValue) {
					switch(this.errorTextType) {
					case '1':
						// data-gc-label属性指定
						if (this.errorTextValue == gclabel) {
							this.itemName = 'errorText';
							return this.SUSPEND;
						}
						break;
					case '2':
						// id属性指定
						if (this.errorTextValue == attrs.get('id')) {
							this.itemName = 'errorText';
							return this.SUSPEND;
						}
						break;
					case '3':
						// class属性指定
						if (this.matchClassAttribute(attrs.get('class'), this.errorTextValue)) {
							this.itemName = 'errorText';
							return this.SUSPEND;
						}
						break;
					case '4':
						// 要素名指定
						if (this.errorTextValue.toLowerCase() == tagName) {
							this.itemName = 'errorText';
							return this.SUSPEND;
						}
						break;
					}
				}
				if (this.panelMode == 'OFF') {
					// パネルモードOFF
					return this.CONTINUE;
				}

				switch(tagName) {
				case 'th':
				case 'td':
				case 'li':
				case 'dt':
				case 'dd':
					// 要素を変えて無害化する
					var step = this.getStep();
					step.mergeAttribute(this.removeAttrs(attrs));
					this.contentTree.addElement(step);
					break;
				case 'form':
				case 'table':
				case 'tbody':
				case 'tr':
				case 'ul':
				case 'dl':
					// この要素自体は無視する
					break;
				default:
					this.contentTree.addElement(step);
					break;
				}
				return this.CONTINUE;
			},

			'/*': function step2sEndOther(tagName) {

				if (this.panelMode == 'OFF') {
					// パネルモードOFF
					return this.CONTINUE;
				}

				switch(tagName) {
				case 'form':
				case 'table':
				case 'tbody':
				case 'tr':
				case 'ul':
				case 'dl':
					// この要素自体は無視する
					break;
				default:
					this.contentTree.endElement();
					break;
				}
				return this.CONTINUE;
			},

			'#text': function step2sText(data) {
				var nbsp = String.fromCharCode( 160 );
				var d = data.replace(nbsp,'');
				if (d.match(/^[ \r\n\t\f]*$/)) {
					return this.CONTINUE;
				}

				if (this.panelMode == 'OFF') {
					// パネルモードOFF
					return this.CONTINUE;
				}

				this.contentTree.addText(data);
				return this.CONTINUE;
			},

			'input': function step2sStartInput(tagName, attrs) {
				var _type = attrs.get('type') || '';
				_type = _type.toLowerCase();

				if (_type == 'checkbox' || _type == 'radio') {
					return this.OUT_RESEND;
				}

				return this.TRASH;
			},

			'select | button | textarea | keygen' : function step2sStartOtherFormComponents(tagName, attrs) {
				return this.TRASH;
			},

			'label': function step2sStartLabel(tagName, attrs) {
				return this.OUT_RESEND;
			},

			'script | noscript' : function step2sStartScript(tagName, attrs) {
				return this.TRASH;
			}

		},

		step3s: {
			'in': function step3sIn(tagName, attrs) {

				if (this.itemName == 'title') {
					this.currentTree = this.titleTree;
				} else {
					this.currentTree = this.contentTree;
					this.currentTree.addElement(this.getItem(this.itemName));
				}
				switch(tagName) {
				case 'th':
				case 'td':
				case 'li':
				case 'dt':
				case 'dd':
					// 要素を変えて無害化する
					var step = this.getStep();
					step.mergeAttribute(this.removeAttrs(attrs));
					this.currentTree.addElement(step);
					break;
				case 'form':
				case 'table':
				case 'tbody':
				case 'tr':
				case 'ul':
				case 'dl':
					// この要素自体は無視する
					break;
				default:
					this.currentTree.addElement(tagName, this.removeAttrs(attrs));
					break;
				}
				return this.CONTINUE;
			},

			'out': function step3sOut(tagName) {
				switch(tagName) {
				case 'form':
				case 'table':
				case 'tbody':
				case 'tr':
				case 'ul':
				case 'dl':
					// この要素自体は無視する
					break;
				default:
					this.currentTree.endElement();
					break;
				}
				if (this.itemName != 'title') {
					this.currentTree.endElement();
				}
				return this.OUT;
			},

			'#text': function step3sText(data) {
				var nbsp = String.fromCharCode( 160 );
				var d = data.replace(nbsp,'');

				if (d.match(/^[ \r\n\t\f]*$/)) {
					return this.CONTINUE;
				}
				this.currentTree.addText(data);
				return this.CONTINUE;
			},

			'input': function step3sStartInput(tagName, attrs) {
				var _type = attrs.get('type') || '';
				_type = _type.toLowerCase();

				if (_type == 'checkbox' || _type == 'radio') {
					return this.OUT_RESEND;
				}
				return this.TRASH;
			},

			'label' : function step3sStartLabel(tagName, attrs) {
				return this.OUT_RESEND;
			},

			'select | button | textarea | keygen' : function step3sStartOtherFormComponents(tagName, attrs) {
				return this.TRASH;
			},

			'*': function step3sStartOther(tagName, attrs) {
				switch(tagName) {
				case 'th':
				case 'td':
				case 'li':
				case 'dt':
				case 'dd':
					// 要素を変えて無害化する
					var step = this.getStep();
					step.mergeAttribute(this.removeAttrs(attrs));
					this.currentTree.addElement(tagName, this.removeAttrs(attrs));
					break;
				case 'form':
				case 'table':
				case 'tbody':
				case 'tr':
				case 'ul':
				case 'dl':
					// この要素自体は無視する
					break;
				default:
					this.currentTree.addElement(tagName, this.removeAttrs(attrs));
					break;
				}
				return this.CONTINUE;
			},

			'/*': function step3sEndOther(tagName) {
				switch(tagName) {
				case 'form':
				case 'table':
				case 'tbody':
				case 'tr':
				case 'ul':
				case 'dl':
					// この要素自体は無視する
					break;
				default:
					this.currentTree.endElement();
					break;
				}
				return this.CONTINUE;
			},

			'script | noscript' : function step3sStartScript(tagName, attrs) {
				return this.TRASH;
			}
		},

		finished: {

			'/#doc' : function finishedEndDoc() {

				if (this.titleTree.isEmpty() &&
						(this.flipTree && this.flipTree.isEmpty()) &&
						this.contentTree.isEmpty()) {
					// ツリーに出力がなければ外枠も出力しない
					return this.EXIT;
				}

				var _wrapper = this.getItem('wrapper');
				var _title = this.getItem('title');

				this.addElement(_wrapper);
				if (this.titleTree.isEmpty()) {
					var _dataRole = _wrapper.getAttribute('data-role') || '';
					var _titleText = '';
					switch(_dataRole){
					case 'fieldcontain':
						_wrapper.setAttribute('class', 'ui-hide-label');
						break;
					}
					_title.setAttribute('class', 'ui-hidden-accessible');
					_titleText = '';

					this.addElement(_title);
					this.addText(_titleText);
					this.endElement();

				} else {
					this.addElement(_title);
					this.addTree(this.titleTree);
					this.endElement();
				}

				if (!this.contentTree.isEmpty()) {
					this.addTree(this.contentTree);
				}

				if (this.flipTree && this.flipTree.isRadio && !this.flipTree.isEmpty()) {
					// フリップスイッチ、ラベルをラップする要素
					var _wrapper = this.getItem('flipswitch');
					this.addElement(_wrapper);
					if (this.flipTree.countAddedStep('step1')) {
						this.flipTree.endElement();
					}
					this.addTree(this.flipTree);	// add select & option elements
					this.flipTree = undefined;
					// 注釈テキストの表示
					if (this.panelMode == 'OFF') {
						if (this.flipIndex < this.footerTexts.length && this.footerTexts[this.flipIndex]) {
							var _note = this.getItem('note');
							if (_note) {
								this.addElement(_note);
								this.addText(this.footerTexts[this.flipIndex]);
								this.endElement();
							} else {
								this.addText(this.footerTexts[this.flipIndex]);
							}
						}
					}
					this.flipIndex++;
					this.endElement(); // close _wrapper element
				}

				return this.EXIT;
			}

		},

		failed : {
			'/#doc' : function failedEndDoc() {
				return this.ERROR;
			}
		}
	};
	gcparts.partsRules[rule._name] =  rule;
}());
