/**
 * 汎用コンポーネント カルーセル
 */

(function() {
	var rule = {
		_name: "JQUERYRSCAROUSEL01",
		_dic: "カルーセル",

		start : {
			'#doc' : function step1StartDoc() {

				var _removes = this.getItem('start.remove');
				var s;
				if (_removes) {
					s = this.getItem('start.remove').getAttribute('value').replace(/\s*/g, '').split(',');
				} else {
					s = [];
				}
				this.a = {};
				for (var i = 0, l = s.length; i < l; i++) {
					var name = s[i].toLowerCase();
					this.a[name] = name;
				}
				this.trimAttributes = function(attrs) {
					var ret = new gcparts.Attributes(attrs);
					for (var attr in attrs.attrs) {
						if (this.a[attr]) {
							ret.remove(attr);
						}
					}
					return ret;
				};

				this.contentTrees = [];
				this.contentCount = 0;
				this.currentTree;

				// オプション値の取得
				this.responsiveMode = this.getParameter('responsiveMode') || 'imageSize';
				if (this.responsiveMode !== 'itemCount') {
					// デフォルトは'imageSize'
					this.responsiveMode = 'imageSize';
				}

				// カルーセルプラグインオプション用のオブジェクト（JSON形式で出力する）
				var jsonObj = {};
				this.displayController = this.getParameter('displayController') || 'ON';
				this.speed = this.getParameter('speed') || 'normal';
				this.autoScroll = this.getParameter('autoScroll') || 'OFF';
				// 停止時間：デフォルト8秒
				this.pause = this.getParameter('pause') || 8;

				return this.OUT;
			},
		},

		step1: {

			'*': function step1StartOther(tagName, attrs) {

				var gclabel = attrs.get("data-gc-label");
				switch(gclabel) {
				case 'contents':
					if (this.countAddedStep('step1') == 0) {
						var step = this.getStep();
						var c = step.getAttribute('class') || '';
						c += ' ' + this.responsiveMode;
						if (gcutil.isGroup('smartphone')) {
							c += ' smartphone';
						} else if(gcutil.isGroup('tablet')) {
							c += ' tablet';
						} else if (gcutil.isGroup('mobile')) {
							c += ' mobile';
						} else if (gcutil.isGroup('pc')) {
							c += ' pc';
						}
						if (gcutil.isGroup('ios')) {
							c += ' ios';
						} else if (gcutil.isGroup('android')) {
							c += ' android';
						} else if (gcutil.isGroup('windowsphone')) {
							c += ' windowsphone';
						} else if (gcutil.isGroup('blackberry')) {
							c += ' blackberry';
						}
						step.setAttribute('class', c);
						this.addElement(step);
					}

					return this.SUSPEND;
				}
				return this.CONTINUE;

			}

		},

		step2s: {

			'in': function step2sIn(tagName, attrs) {
				var gclabel = attrs.get("data-gc-label");
				var gclabelIndex = attrs.getInt('data-gc-labelindex');
				this.addParent = 0;

				switch(gclabel) {
				case 'contents':

					if (gclabelIndex >= 0) {
						this.contentTrees[gclabelIndex] = new gcparts.ElementTree(gclabel);
						this.currentTree = this.contentTrees[gclabelIndex];
					} else {
						this.contentTrees[this.contentCount + '-gc'] = new gcparts.ElementTree(gclabel);
						this.currentTree = this.contentTrees[this.contentCount + '-gc'];
						this.contentCount++;
					}

					this.currentTree.addElement(this.getStep());
					this.addParent++;

					var attrs2 = this.trimAttributes(attrs);
					var gclabel = attrs.get("data-gc-label");
					if (gclabel) {
						var c = attrs2.get('class') || '';
						c += ' ' + gclabel;
						attrs2.set('class', c);
					}

					switch(tagName) {
					case 'li':
					case 'dt':
					case 'dd':
					case 'th':
					case 'td':
						this.currentTree.addElement('div', attrs2);
						this.addParent++;
						break;
					case 'tbody':
					case 'tr':
						this.currentTree.addElement('table');
						this.addParent++;
						this.currentTree.addElement(tagName, attrs2);
						this.addParent++;
						break;

					case 'img':
						var img = this.getItem('step2s.image');
						var src = attrs.get('src') || '';
						img.setAttribute('data-src', src);
						img.setAttribute('src', src);
						this.currentTree.addElement(img);
						this.addParent++;
						break;
					default:
						this.currentTree.addElement(tagName, attrs2);
						this.addParent++;
						break;
					}
					return this.CONTINUE;
				}
				return this.STAY;
			},

			'out': function step2sOut(tagName) {
				for (var i = 0; i < this.addParent; i++) {
					this.currentTree.endElement();
				}
				return this.OUT;
			},

			'img': function step2sStartImage(tagName, attrs) {
				var img = this.getItem('step2s.image');

				var src = attrs.get('src') || '';
				img.setAttribute('data-src', src);
				img.setAttribute('src', src);

				var gclabel = attrs.get("data-gc-label");
				if (gclabel) {
					var c = img.getAttribute('class') || c;
					c += ' ' + gclabel;
					img.setAttribute('class', c);
				}
				this.currentTree.addElement(img);
				this.currentTree.endElement();
				return this.CONTINUE;
			},

			'*': function step2sStartOther(tagName, attrs) {
				var attrs2 = this.trimAttributes(attrs);
				var gclabel = attrs.get("data-gc-label");
				if (gclabel) {
					var c = attrs2.get('class') || '';
					c += ' ' + gclabel;
					attrs2.set('class', c);
				}
				this.currentTree.addElement(tagName, attrs2);
				return this.CONTINUE;
			},

			'#text': function step2sText(data) {
				var nbsp = String.fromCharCode( 160 );
				var d = data.replace(nbsp,'');
				if (!d.match(/^[ \r\n\t\f]*$/)) {
					this.currentTree.addText(data);
				}
				return this.CONTINUE;
			},

			'/*': function step2sEndOther(tagName) {
				this.currentTree.endElement();
				return this.CONTINUE;
			}

		},

		'finished' : {
			'/#doc' : function finishedEndDoc() {

				if (this.contentTrees.length == 0) {
					gclog.debug('carousel Array length is 0. return EXIT', 2);
					return this.EXIT;
				}
				var runnerElem = this.getItem('finished.runner');
				this.addElement(runnerElem);
				// carousel items
				for (var pname in this.contentTrees){
					this.addTree(this.contentTrees[pname]);
				}
				// close runner
				this.endElement();

				var jsonObj = {};
				if (this.displayController === 'ON') {
					jsonObj["nextPrevActions"] = true;
					jsonObj["pagination"] = true;
				} else {
					jsonObj["nextPrevActions"] = false;
					jsonObj["pagination"] = false;
				}
				jsonObj["speed"] = this.speed;
				if (this.autoScroll === 'ON') {
					jsonObj["autoScroll"] = true;
				} else {
					jsonObj["autoScroll"] = false;
				}
				jsonObj["continuous"] = true;
				jsonObj["pause"] = (this.pause - 0) * 1000;

				var libObtion = this.getItem('finished.libOption');
				var libJson;
				try {
					libJson = JSON.stringify(jsonObj);
				} catch(err) {
					gclog.error('cannot JSON.stringify to libOption', 2);
					gclog.error(err, 2);
				}
				if (libObtion && libJson) {
					this.addElement(libObtion);
					this.addText(libJson);
					this.endElement();
				}
				return this.EXIT;
			}
		},

		'failed' : {
			'/#doc' : function failedEndDoc() {
				return this.ERROR;
			}
		}
	};
	gcparts.partsRules[rule._name] =  rule;
}());
