/**
 * 汎用コンポーネント アコーディオン
 */

(function() {
	var rule = {
		_name: "JQUERYUIACCORDION01",
		_dic: "アコーディオン",

		start : {
			'#doc' : function step1StartDoc() {

				var _removes = this.getItem('start.remove');
				var s;
				if (_removes) {
					s = this.getItem('start.remove').getAttribute('value').replace(/\s*/g, '').split(',');
				} else {
					s = [];
				}
				this.a = {};
				for (var i = 0, l = s.length; i < l; i++) {
					var name = s[i].toLowerCase();
					this.a[name] = name;
				}
				this.trimAttributes = function(attrs) {
					var ret = new gcparts.Attributes(attrs);
					for (var attr in attrs.attrs) {
						if (this.a[attr]) {
							ret.remove(attr);
						}
					}
					return ret;
				};

				// アコーディオン見出し・コンテンツ用バッファ
				this.accordionTrees = [];

				this.step1Elem;
				this.step2sElem;

				this.headCount = 0;
				this.contentCount = 0;
				this.currentTree;

				// アコーディオンプラグインオプション用のオブジェクト（JSON形式で出力する）
				var jsonObj = {};
				this.collapsible = this.getParameter('collapsible') || 'ON';
				this.active = this.getParameter('active') || false;
				this.heightStyle = this.getParameter('heightStyle') || 'content';
				this.icon = this.getParameter('icon') || 'arrow';

				return this.OUT;
			},
		},

		step1: {

			'*': function step1StartOther(tagName, attrs) {

				var gclabel = attrs.get("data-gc-label");
				var gclabelIndex = attrs.getInt('data-gc-labelindex');
				this.step1Elem = this.step1Elem || this.getStep();

				switch(gclabel) {
				case 'title':
					if (gclabelIndex >= 0) {
						this.accordionTrees[gclabelIndex] = this.accordionTrees[gclabelIndex] || {};
						this.accordionTrees[gclabelIndex][gclabel] = new gcparts.ElementTree(gclabel);
						this.currentTree = this.accordionTrees[gclabelIndex][gclabel];
					} else {
						var idx = this.headCount + '-gc';
						this.accordionTrees[idx] = this.accordionTrees[idx] || {};
						this.accordionTrees[idx][gclabel] = new gcparts.ElementTree(gclabel);
						this.currentTree = this.accordionTrees[idx][gclabel];
						this.headCount++;
					}
					this.currentTree.addElement(this.getStep());
					this.addParent = 1;
					return this.SUSPEND;

				case 'contents':
					this.addParent = 0;
					return this.SUSPEND;
				}

				return this.CONTINUE;
			}

		},

		step2s: {

			'in': function step2sIn(tagName, attrs) {
				var gclabel = attrs.get("data-gc-label");
				var gclabelIndex = attrs.getInt('data-gc-labelindex');
				this.step2sElem = this.step2sElem || this.getStep();

				this.label = gclabel;

				switch(gclabel) {
				case 'title':

					switch(tagName) {
					case 'img':
						var alt = attrs.get('alt');
						if (alt) {
							this.currentTree.addText(alt);
						}
						break;
					}
					return this.CONTINUE;

				case 'contents':

					if (gclabelIndex >= 0) {
						this.accordionTrees[gclabelIndex] = this.accordionTrees[gclabelIndex] || {};
						this.accordionTrees[gclabelIndex][gclabel] = new gcparts.ElementTree(gclabel);
						this.currentTree = this.accordionTrees[gclabelIndex][gclabel];
					} else {
						var idx = this.contentCount + '-gc';
						this.accordionTrees[idx] = this.accordionTrees[idx] || {};
						this.accordionTrees[idx][gclabel] = new gcparts.ElementTree(gclabel);
						this.currentTree = this.accordionTrees[idx][gclabel];
						this.contentCount++;
					}
					this.currentTree.addElement(this.getStep());
					this.addParent++;

					var attrs2 = this.trimAttributes(attrs);
					var gclabel = attrs.get("data-gc-label");
					if (gclabel) {
						var c = attrs2.get('class') || '';
						c += ' ' + gclabel;
						attrs2.set('class', c);
					}
					switch(tagName) {
					case 'li':
					case 'dt':
					case 'dd':
					case 'th':
					case 'td':
						tagName = 'div';
						break;
					case 'tbody':
					case 'tr':
						this.currentTree.addElement('table');
						this.addParent++;
						break;
					case 'img':
						attrs2.set('data-src', attrs.get('src'));
						break;
					}
					this.currentTree.addElement(tagName, attrs2);
					this.addParent++;

					return this.CONTINUE;
				}
				return this.STAY;
			},

			'out': function step2sOut(tagName) {
				for (var i = 0; i < this.addParent; i++) {
					this.currentTree.endElement();
				}
				return this.OUT;
			},

			'*': function step2sStartOther(tagName, attrs) {
				if (this.label == 'title' && tagName != 'img') {
					return this.CONTINUE;
				}

				var attrs2 = this.trimAttributes(attrs);
				var gclabel = attrs.get("data-gc-label");
				if (gclabel) {
					var c = attrs2.get('class') || '';
					c += ' ' + gclabel;
					attrs2.set('class', c);
				}
				if (tagName == 'img') {
					attrs2.set('data-src', attrs.get('src'));
				}

				this.currentTree.addElement(tagName, attrs2);
				return this.CONTINUE;
			},

			'#text': function step2sText(data) {
				var nbsp = String.fromCharCode( 160 );
				var d = data.replace(nbsp,'');
				if (!d.match(/^[ \r\n\t\f]*$/)) {
					this.currentTree.addText(data);
				}
				return this.CONTINUE;
			},

			'/*': function step2sEndOther(tagName) {
				if (this.label == 'title' && tagName != 'img') {
					return this.CONTINUE;
				}
				this.currentTree.endElement();
				return this.CONTINUE;
			}

		},

		'finished' : {
			'/#doc' : function finishedEndDoc() {

				if (this.accordionTrees.length == 0) {
					gclog.debug('accordion Array length is 0. return EXIT', 2);
					return this.EXIT;
				}

				var wrapper = this.getItem('finished.wrapper');
				var c = wrapper.getAttribute('class') || '';

				if (gcutil.isGroup('smartphone')) {
					c += ' smartphone';
				} else if(gcutil.isGroup('tablet')) {
					c += ' tablet';
				} else if (gcutil.isGroup('mobile')) {
					c += ' mobile';
				} else if (gcutil.isGroup('pc')) {
					c += ' pc';
				}
				if (gcutil.isGroup('ios')) {
					c += ' ios';
				} else if (gcutil.isGroup('android')) {
					c += ' android';
				} else if (gcutil.isGroup('windowsphone')) {
					c += ' windowsphone';
				} else if (gcutil.isGroup('blackberry')) {
					c += ' blackberry';
				}
				wrapper.setAttribute('class', c);
				this.addElement(wrapper);

				// accordion titles & contents
				this.accordionTrees.sort();
				for (var idx in this.accordionTrees) {
					if(isNaN(idx) && !idx.match(/-gc$/)) {
						continue;
					}
					var trees = this.accordionTrees[idx];
					if (trees['title']) {
						this.addTree(trees['title']);
					} else {
						this.addElement(this.step1Elem.cloneWithDeepAttrs());
						this.addText('');
						this.endElement();
					}
					if (trees['contents']) {
						this.addTree(trees['contents']);
					} else {
						this.addElement(this.step2sElem.cloneWithDeepAttrs());
						this.addText('');
						this.endElement();
					}
				}

				var jsonObj = {};
				jsonObj["collapsible"] = (this.collapsible == 'ON');

				if (this.active === false || isNaN(this.active)) {
					jsonObj["active"] = false;
					jsonObj["collapsible"] = true;
				} else {
					jsonObj["active"] = this.active - 0;
				}
				jsonObj["heightStyle"] = this.heightStyle;

				switch(this.icon) {
				case 'arrow':
					jsonObj["icons"] = { "header": "icon-arrow-down", "activeHeader": "icon-arrow-up" };
					break;
				case 'plus-minus':
					jsonObj["icons"] = { "header": "icon-plus", "activeHeader": "icon-minus" };
					break;
				}

				var libObtion = this.getItem('finished.libOption');
				var libJson;
				try {
					libJson = JSON.stringify(jsonObj);
				} catch(err) {
					gclog.error('cannot JSON.stringify to libOption', 2);
					gclog.error(err, 2);
				}
				if (libObtion && libJson) {
					this.addElement(libObtion);
					this.addText(libJson);
					this.endElement();
				}
				return this.EXIT;
			}
		},

		'failed' : {
			'/#doc' : function failedEndDoc() {
				return this.ERROR;
			}
		}
	};
	gcparts.partsRules[rule._name] =  rule;
}());
