/**
 * 汎用コンポーネント タブ
 */

(function() {
	var rule = {
		_name: "JQUERYUITAB01",
		_dic: "タブ",

		start : {
			'#doc' : function step1StartDoc() {

				var _removes = this.getItem('start.remove');
				var s;
				if (_removes) {
					s = this.getItem('start.remove').getAttribute('value').replace(/\s*/g, '').split(',');
				} else {
					s = [];
				}
				this.a = {};
				for (var i = 0, l = s.length; i < l; i++) {
					var name = s[i].toLowerCase();
					this.a[name] = name;
				}
				this.trimAttributes = function(attrs) {
					var ret = new gcparts.Attributes(attrs);
					for (var attr in attrs.attrs) {
						if (this.a[attr]) {
							ret.remove(attr);
						}
					}
					return ret;
				};

				// オプション値の取得
				this.active = this.getParameter('active') || 0;
				this.coloumDesignType = this.getParameter('coloumDesignType') || 'OFF';

				// ツリー出力用バッファ
				this.step1Element;
				this.titleTrees = [];
				this.contentTrees = [];

				this.headCount = 0;
				this.contentCount = 0;

				return this.OUT;
			},
		},

		step1: {

			'*': function step1StartOther(tagName, attrs) {

				var gclabel = attrs.get("data-gc-label");
				switch(gclabel) {
				case 'title':
					if (this.headCount == 0) {
						this.step1Element = this.getStep();
					}
					return this.SUSPEND;

				case 'contents':
					return this.SUSPEND;
				}
				return this.CONTINUE;
			}
		},

		step2s: {

			'in': function step2sIn(tagName, attrs) {
				var gclabel = attrs.get("data-gc-label");
				var gclabelIndex = attrs.getInt('data-gc-labelindex');
				this.addParent = 0;

				this.label = gclabel;

				switch(gclabel) {
				case 'title':

					var step = this.getStep();
					var href = step.getAttribute('href') || '#tabs';

					if (gclabelIndex >= 0) {

						this.titleTrees[gclabelIndex] = new gcparts.ElementTree(gclabel);
						this.currentTree = this.titleTrees[gclabelIndex];
						href += '-' + (gclabelIndex + 1);
						step.setAttribute('href', href);

					} else {

						var idx = this.headCount + '-gc';

						this.titleTrees[idx] = new gcparts.ElementTree(gclabel);
						this.currentTree = this.titleTrees[idx];

						var no = this.headCount + 1;
						href += '-' + no + '-gc';
						step.setAttribute('href', href);
						this.headCount++;
					}

					this.currentTree.addElement(step);
					this.addParent++;

					switch(tagName) {
					case 'img':
						var alt = attrs.get('alt');
						if (alt) {
							this.currentTree.addText(alt);
						}
						break;
					}

					return this.CONTINUE;

				case 'contents':

					var item = this.getItem('step2s.content');
					var id = item.getAttribute('id') || 'tabs';

					if (gclabelIndex >= 0) {

						this.contentTrees[gclabelIndex] = new gcparts.ElementTree(gclabel);
						this.currentTree = this.contentTrees[gclabelIndex];
						id += '-' + (gclabelIndex + 1);
						item.setAttribute('id', id);

					} else {

						var idx = this.contentCount + '-gc';
						this.contentTrees[idx] = new gcparts.ElementTree(gclabel);
						this.currentTree = this.contentTrees[idx];

						var no = this.contentCount + 1;
						id += '-' + no + '-gc';
						item.setAttribute('id', id);
						this.contentCount++;
					}

					this.currentTree.addElement(item);
					this.addParent++;

					var attrs2 = this.trimAttributes(attrs);
					var gclabel = attrs.get("data-gc-label");
					if (gclabel) {
						var c = attrs2.get('class') || '';
						c += ' ' + gclabel;
						attrs2.set('class', c);
					}
					switch(tagName) {
					case 'li':
					case 'dt':
					case 'dd':
					case 'th':
					case 'td':
						tagName = 'div';
						break;
					case 'tbody':
					case 'tr':
						this.currentTree.addElement('table');
						this.addParent++;
						break;
					}
					this.currentTree.addElement(tagName, attrs2);
					this.addParent++;

					return this.CONTINUE;
				}
				return this.STAY;
			},

			'out': function step2sOut(tagName) {
				for (var i = 0; i < this.addParent; i++) {
					this.currentTree.endElement();
				}
				this.label = undefined;
				return this.OUT;
			},

			'*': function step2sStartOther(tagName, attrs) {

				if (this.label == 'title' && tagName != 'img') {
					return this.CONTINUE;
				}

				var attrs2 = this.trimAttributes(attrs);
				var gclabel = attrs.get("data-gc-label");
				if (gclabel) {
					var c = attrs2.get('class') || '';
					c += ' ' + gclabel;
					attrs2.set('class', c);
				}
				this.currentTree.addElement(tagName, attrs2);
				return this.CONTINUE;
			},

			'#text': function step2sText(data) {
				var nbsp = String.fromCharCode( 160 );
				var d = data.replace(nbsp,'');
				if (!d.match(/^[ \r\n\t\f]*$/)) {
					this.currentTree.addText(data);
				}
				return this.CONTINUE;
			},

			'/*': function step2sEndOther(tagName) {

				if (this.label == 'title' && tagName != 'img') {
					return this.CONTINUE;
				}
				this.currentTree.endElement();
				return this.CONTINUE;
			}

		},

		'finished' : {
			'/#doc' : function finishedEndDoc() {

				if (this.titleTrees.length == 0 && this.contentTrees.length == 0) {
					gclog.debug('tab Array length is 0. return EXIT', 2);
					return this.EXIT;
				}

				var wrapper = this.getItem('finished.wrapper');
				var c = wrapper.getAttribute('class') || '';

				if (gcutil.isGroup('smartphone')) {
					c += ' smartphone';
				} else if(gcutil.isGroup('tablet')) {
					c += ' tablet';
				} else if (gcutil.isGroup('mobile')) {
					c += ' mobile';
				} else if (gcutil.isGroup('pc')) {
					c += ' pc';
				}
				if (gcutil.isGroup('ios')) {
					c += ' ios';
				} else if (gcutil.isGroup('android')) {
					c += ' android';
				} else if (gcutil.isGroup('windowsphone')) {
					c += ' windowsphone';
				} else if (gcutil.isGroup('blackberry')) {
					c += ' blackberry';
				}
				wrapper.setAttribute('class', c);
				this.addElement(wrapper);

				this.addElement(this.step1Element);

				// tab titles
				for (var pname in this.titleTrees){
					this.addTree(this.titleTrees[pname]);
				}

				// close step1Element
				this.endElement();

				// tab contents
				for (var pname in this.contentTrees){
					this.addTree(this.contentTrees[pname]);
				}

				var jsonObj = {};
				jsonObj["active"] = this.active;
				jsonObj["gcColoumDesignType"] = (this.coloumDesignType == 'ON');

				var libObtion = this.getItem('finished.libOption');
				var libJson;
				try {
					libJson = JSON.stringify(jsonObj);
				} catch(err) {
					gclog.error('cannot JSON.stringify to libOption', 2);
					gclog.error(err, 2);
				}
				if (libObtion && libJson) {
					this.addElement(libObtion);
					this.addText(libJson);
					this.endElement();
				}
				return this.EXIT;
			}
		},

		'failed' : {
			'/#doc' : function failedEndDoc() {
				return this.ERROR;
			}
		}
	};
	gcparts.partsRules[rule._name] =  rule;
}());
