/*1.1.0*/
/*
 * genecode javascript utilities.
 */
(function() {
	// 画像変換指示パラメータ名
	var imgConvertParamName = "_gccmd";

	//--------------------------------------------------
	// functions
	//--------------------------------------------------
	gcutil.toHtml = function toHtml(obj) {
		if (obj === null) {
			gcutil.out("null");
			return;
		} else if(obj === undefined) {
			gcutil.out("undefined");
			return;
		}
	
		if (obj instanceof String || typeof obj == 'string') {
			obj = $(gcutil.getElementsByMark(obj));
		}
		
		if (!obj.jquery) {
			return;
		}
		
		for ( var i = 0; i < obj.length; i++) {
			var str = obj.get(i).outerHTML;
			gcutil.out(str);
		}
	};

	gcutil.toDebugHtml = function toDebugHtml(obj) {
		if (obj === null) {
			gclog.debug("null");
			return;
		} else if(obj === undefined) {
			gclog.debug("undefined");
			return;
		}
		
		if (obj instanceof String || typeof obj == 'string') {
			obj = $(gcutil.getElementsByMark(obj));
		}

		if (!obj.jquery) {
			return;
		}
		
		for ( var i = 0; i < obj.length; i++) {
			var str = obj.get(i).outerHTML;
			gclog.debug(str);
		}
	};

	/**
	 * 320pxベース
	 */
	gcutil.writeViewport = function writeViewport() {
		var ua = gcutil.getHeader("User-Agent");
		if(ua && (ua.indexOf("iPhone") != -1 || ua.indexOf("iPad") != -1 || ua.indexOf("iPod") != -1)) {
			gcutil.out('<meta name="viewport" content="width=device-width,initial-scale=1.0,minimum-scale=1.0,maximum-scale=1.0,user-scalable=no">');
		} else {
			gcutil.out('<meta name="viewport" content="width=device-width,initial-scale=1.0,minimum-scale=1.0,maximum-scale=1.0,user-scalable=no,target-densitydpi=medium-dpi">');
		}
	};

	/**
	 * 640pxベース
	 */
	gcutil.write640Viewport = function writeViewport() {
		var ua = gcutil.getHeader("User-Agent");
		var bw = gcutil.getTerminfoProperty('browserWidth');
		var pr = gcutil.getTerminfoProperty('pixelRatio');
		var bt = gcutil.getTerminfoProperty('browserType');

		if(ua && (ua.indexOf("iPhone") != -1 || ua.indexOf("iPad") != -1 || ua.indexOf("iPod") != -1)) {
			// iOS
			gcutil.out('<meta name="viewport" content="width=640, user-scalable=no">');
		} else if (gcruntime.isGroup("android2x")) {
			// Android 2.X
			gcutil.out('<meta name="viewport" content="width=device-width,target-densitydpi=320,initial-scale=0.5,minimum-scale=0.5,maximum-scale=0.5,user-scalable=no">');
		} else {
			// Android 4.X and other
			if (bt == 'chrome') {
				gcutil.out('<meta name="viewport" content="width=640, user-scalable=no">');
			} else if(pr == 3){
				gcutil.out('<meta name="viewport" content="width=device-width,target-densitydpi=320,initial-scale=1,minimum-scale=1,maximum-scale=1,user-scalable=no">');
			} else if(pr == 2){
				gcutil.out('<meta name="viewport" content="width=device-width,target-densitydpi=device-dpi,initial-scale=0.5,minimum-scale=0.5,maximum-scale=0.5,user-scalable=no">');
			} else {
				gcutil.out('<meta name="viewport" content="width=device-width,target-densitydpi=320,initial-scale=1,minimum-scale=1,maximum-scale=1,user-scalable=no">');
			}
		}
	};

	/**
	 * 640pxベース(ピンチイン/アウト)
	 */
	gcutil.write640ScalableViewport = function writeScalableViewport() {
		var ua = gcutil.getHeader("User-Agent");
		var bw = gcutil.getTerminfoProperty('browserWidth');
		var pr = gcutil.getTerminfoProperty('pixelRatio');
		var bt = gcutil.getTerminfoProperty('browserType');

		if(ua && (ua.indexOf("iPhone") != -1 || ua.indexOf("iPad") != -1 || ua.indexOf("iPod") != -1)) {
			// iOS
			gcutil.out('<meta name="viewport" content="width=640, user-scalable=yes">');
		} else if (gcruntime.isGroup("android2x")) {
			// Android 2.X
			gcutil.out('<meta name="viewport" content="target-densitydpi=device-dpi,width=640,user-scalable=yes">');
		} else {
			// Android 4.X and other
			if(pr == 3){
				gcutil.out('<meta name="viewport" content="width=640,initial-scale=0.5,user-scalable=yes">');
			} else if(pr == 2 && bt == 'chrome'){
				gcutil.out('<meta name="viewport" content="width=640,user-scalable=yes">');
			} else if(pr == 2){
				gcutil.out('<meta name="viewport" content="width=device-width,target-densitydpi=device-dpi,initial-scale=0.5,user-scalable=yes">');
			} else {
				gcutil.out('<meta name="viewport" content="target-densitydpi=device-dpi,width=640,user-scalable=yes">');
			}
		}
	};
	
	
	/**
	 * PCサイトからscriptタグを取得する。
	 * オプションで除外する条件を指定できる。
	 *
	 * ex)
	 * except: [
	 *   { type: 'src', cond: /regex or string/ },
	 *   { type: 'src', cond: /regex or string/ },
	 *   { type: 'text', cond: /regex or string/ },
	 *   { type: 'text', cond: /regex or string/ },
	 * ]
	 * replace: [
	 *   { oldSubstr: /regex or string/, newSubstr: /regex or string/ },
	 *   { oldSubstr: /regex or string/, newSubstr: /regex or string/ },
	 * ]
	 *
	 * except配列になれべられた条件はor条件
	 */
	// 例)
	// bodyタグ内のscriptを読み込み
	// gutils.loadScriptTag('body script',{
	//   except: [
	//     { type: 'src', cond: /jquery-.*/ },
	//     { type: 'src', cond: /jquery\.ui.*/ },
	//     { type: 'src', cond: /jquery\.marquee.*/ },
	//     { type: 'text', cond: /sortable|marque/ },
	//   ],
	//   replace: [
	//     { oldSubstr: /www.symmetric.co.jp/g, newSubstr: 'sp.symmetric.co.jp' },
	//     { oldSubstr: /href=/, newSubstr: 'onclick=' },
	//   ]
	// });
	gcutil.loadScriptTag = function loadScriptTag(selector, opt) {
		// PCページからscriptタグを取得
		var $scripts = $(selector);
		opt = opt || {};
		var except = opt['except'] || [];
		var replace = opt['replace'] || [];
		var replace_path = opt['replace_path'] || [];


		if(except) {
			// filterメソッドで絞り込み
			$scripts = $scripts.filter(function() {
				var $script = $(this)
					, src = $script.attr('src')
					, text = $script.text()
					, i
					, len = except.length
					, type
					, cond
					;
				for(i = 0; i < len; ++i) {
					type = except[i].type;
					cond = except[i].cond;
					if(type === 'src' && src && src.match(cond)) {
						return false;
					}
					if(type === 'text' && text && text.match(cond)) {
						return false;
					}
				}
				// exceptリストにマッチしなければ残す
				return true;
			});
		}

		if(replace && replace.length > 0) {
			$scripts.each(function(){
				var LEN = replace.length
				, scrStr = $(this).text()
				, oldSubstr
				, newSubstr;
				for (var i = 0; i < LEN; i++) {
					oldSubstr = replace[i].oldSubstr;
					// 置換前文字列がない場合、もしくはからの場合は置換しない
					if(!oldSubstr){
						continue;
					}
					newSubstr = replace[i].newSubstr;
					scrStr = scrStr.replace(oldSubstr, newSubstr);
				}
				//内容が書き換わっている時のみ置き換える
				if($(this).text() !== scrStr){
					$(this).text(scrStr);
				}
			})
		}


		if(replace_path && replace_path.length > 0) {
			$scripts.each(function(){
				var LEN = replace_path.length
				, scrStr = $(this).attr('src')
				, oldSubstr
				, newSubstr;
				for (var i = 0; i < LEN; i++) {
					oldSubstr = replace_path[i].oldSubstr;
					// 置換前文字列がない場合、もしくはからの場合は置換しない
					if(!oldSubstr){
						continue;
					}
					newSubstr = replace_path[i].newSubstr;
					if(scrStr){
						scrStr = scrStr.replace(oldSubstr, newSubstr);
					}
				}
				//内容が書き換わっている時のみ置き換える
				if($(this).attr('src') !== scrStr){
					$(this).attr('src',scrStr);
				}
			})
		}

		// SPページにscriptタグを書き出し
		gcutil.toHtml($scripts);
	};

	gcutil.writeCanonical = function writeCanonical() {
		var $link = $('<link rel="canonical" />');
		var href = gcutil.getSourceUrl(true);
		$link.attr("href", href);
		gcutil.toHtml($link);
	};

	//--------------------------------------------------
	// jQuery extend
	//--------------------------------------------------

	$.fn.extend({

		gc_image_resize : function(w) {
			gclog.debug("utils jquery.extend.gc_image_resize start");
			if (this.size() == 0) {
				return this;
			}
			this.each(function() {
				var img;
				if ($(this).get(0).tagName.toLowerCase() == "img") {
					img = $(this);
				} else {
					img = $(this).find("img");
				}

				$(img).each(function() {
					var src = $(this).attr("src");
					var gccommand = "";
					gclog.debug("utils jquery.extend.resize src=" + src);
					if (src == undefined || src == null || src.length == 0) {
						return true; // continue;
					}
					var gci = src.indexOf(imgConvertParamName + "=");
					gccommand = (gci > -1) ? (src.substring(gci)) : "";
					if (gccommand.length == 0) {
						gccommand = imgConvertParamName + "=" + escape("resize=" + (w || 320));
					} else {
						gccommand = escape("&resize=" + (w || 320));
					}
					var qi = src.indexOf("?");
					var qs = (qi > -1) ? (src.substring(qi)) : "";
					var s;
					if (qs.length >= 2) {
						s = src + "&" + gccommand;
					} else {
						s = src + "?" + gccommand;
					}

					$(this).attr("src", s);
					$(this).removeAttr("width");
					$(this).removeAttr("height");
				});
			});
			return this;
		},

		gc_image_clip : function(fx, fy, tx, ty) {
			gclog.debug("utils jquery.extend.gc_image_clip start");
			if (this.size() == 0) {
				return this;
			}
			this.each(function() {
				var img;
				if ($(this).get(0).tagName.toLowerCase() == "img") {
					img = $(this);
				} else {
					img = $(this).find("img");
				}

				$(img).each(
						function() {
							var src = $(this).attr("src");
							var gccommand = "";
							gclog.debug("utils jquery.extend.resize src=" + src);
							if (src == undefined || src == null || src.length == 0) {
								return true; // continue;
							}
							var gci = src.indexOf(imgConvertParamName + "=");
							gccommand = (gci > -1) ? (src.substring(gci)) : "";
							if (gccommand.length == 0) {
								gccommand = imgConvertParamName + "="
										+ escape("clip=" + fx + "," + fy + "," + tx + "," + ty);
							} else {
								gccommand = escape("&clip=" + fx + "," + fy + "," + tx + "," + ty);
							}
							var qi = src.indexOf("?");
							var qs = (qi > -1) ? (src.substring(qi)) : "";
							var s;
							if (qs.length >= 2) {
								s = src + "&" + gccommand;
							} else {
								s = src + "?" + gccommand;
							}
							$(this).attr("src", s);
							$(this).removeAttr("width");
							$(this).removeAttr("height");
						});
			});
			return this;
		}

	});


}());

